<?php

class Templates {
	
	public static function page(&$arr) {
		global $def;
		
		//перекрытие
		$default = array(
			'doctype' => esse($def, 'page', 'doctype'),
			'metas' => esse($def, 'page', 'metas'),
			'styles' => esse($def, 'page', 'styles'),
			'scripts' => esse($def, 'page', 'scripts'),
			'title' => esse($arr, 'title'),
			'body_attrs' => esse($arr, 'body_attrs'),
			'header' => esse($arr, 'header'),
			'menu' => esse($arr, 'menu'),
			'body' => esse($arr, 'body'),
			'footer' => esse($arr, 'footer'),
		);
		if (empty($default['title'])) $default['title'] = $def['site']['title'];
		//вот и весь "интерфейс"!
		
		extract($default);
		return <<<TPL
{$doctype}
<head>
	{$metas}
	<title>{$title}</title>
	{$styles}
	{$scripts}
</head>
<body{$body_attrs}>
	{$header}
	<div class="menutop">{$menu}</div>	
	{$body}
	{$footer}
</body>

TPL;
	} //function tpl_page
	
	public static function table(&$arr) {
		//перекрытие
		$default = array(
			'table' => esse($arr, 'table'),
			'caption' => esse($arr, 'caption'),
			'cols' => esse($arr, 'cols'),
			'thead' => esse($arr, 'thead'),
			'tbody' => esse($arr, 'tbody'),
		);
		
		extract($default);
	return <<<TPL
<table class="{$table}">
	<caption>{$caption}</caption>
	<colgroup>{$cols}</colgroup>
	<thead>{$thead}</thead>
	<tbody>{$tbody}</tbody>
</table>
TPL;
	}
	
	public static function item($item) {
		return <<<TPL
<div class="item">
	
	{$item}
</div>
TPL;
	}
	
	public static function footer(&$arr = array()) {
		
		return <<<TPL
	<div class='distr'>
	<h4><a href='./repa/'>дистрибутивы</a> маленького фреймворка (версии)</h4>
	<p><a href='http://ir2.ru/quiproquo.aspx'>Что из чего следует во фреймворке «Friends»</a> (общая схема, 29.10.11)</p>
	<p><a href='http://ir2.ru/php_framework.aspx'>php-фреймворк анти-MVC-ООП</a>, описание (17.10.11)</p>
	</div>
TPL;
	}
	
}