<?php

class View {
	
	protected $data;
	protected $fields = array();
	protected $subj;
	protected $view;
	
	public function __construct($subj = null, $view = null) {
		global $def;
		$def['title'] = $def['meta'][$subj]['title'];
		if (null == $subj) $subj = esse($def, 'subj');
		$this->subj = $subj;
		if (null == $view) $view = ($def['request']['full_key']) ? 'item' : 'table';
		$this->view = $view;
		
		$data = Data::get($subj);
		$this->data = $data;
		//print_r($this->data);
		$this->out($data, $view);
	}
	
	private function find_func($data) {
		global $def;
		//запускаем ф-цию только для уникально выбранной записи
		if (!$def['request']['full_key']) return null;
	
		$meta = $def['meta'][$this->subj];		
		$data = $data['data'];
		$data = each($data);
		$data = $data['value'];
		
		return esse($data, 'func');
	}
	
	private function out($data, $view) {
		global $def;
		$meta = $def['meta'][$this->subj];		
		$table = $meta['table'];
		$func = $this->find_func($data);
		if ($func) $class = new $table;
		
		$arr = array();
		$arr['title'] = esse($meta, 'title');
		$source = esse($meta, 'type');
		if ($source) $arr['title'] .= ' (source: ' . $source . ')';
		
		$arr['menu'] = $this->build_menu();
		$method = 'build_' . $view;
		
		$arr['body'] = ($func && $class) ? $class->$func() : $this->$method($table);
		
		$add = esse($meta, 'add');
		if ($add && !$func) {
			foreach ($add as $essence) {
				$c_view = esse($def['meta'], $essence, 'view');
				$this->data = Data::get($essence);
				$method = 'build_' . $c_view;
				$str = $this->$method();
				$arr['body'] .= $str;
			}
		}
				
		$arr['footer'] = ($def['request']['full_key']) ? '' : Templates::footer();
		
		print Templates::page($arr);
	}
	
	private function build_raw() {
		
		$data = $this->data;
		$str = $data['data'][0][0];
		return sprintf(self::htpl(2, 'pre'), $str);
	}
	
	private function build_menu() {
	
		global $def; 
		$meta = $def['meta'];
		
		$menu = array();
		foreach ($meta as $subj => $arr) {
			$file = $subj . $def['ext'];
			if ($file == $def['request']['file']) $file = false;
			
			if ($arr['menu']) //произвольно: отображать или нет в меню
				$menu[] = array('href' => urlencode($file), 'text' => def_e($arr['title']));
		}
		
		$out = array();
		foreach($menu as $arr) {
			$out[] = (!empty($arr['href'])) 
				? sprintf(self::htpl(2, 'a', 'href'), $arr['text'], $arr['href'])
				: sprintf(self::htpl(2, 'span'), $arr['text']);
		}
		return implode(' | ', $out);
	}
		
	//subclass Table
	
	private function build_table($table) {
		global $def;
		$subj = $this->subj;
		$arr = array();
		$arr['caption'] = $def['title'];
		
		$head = $this->build_head($table);
		$arr['thead'] = $head['thead'];
		$arr['cols'] = $head['cols'];
		$arr['tbody'] = $this->build_tbody($this->data, $table);

		return Templates::table($arr);
	}
	
	private function fields_for_list($table) {
		/** Выбирает поля из Модели, которые должны отображаться при выводе в виде таблицы */
		$fields = $this->fields;
		if (isset($fields[$table])) return $fields[$table];
		
		global $def;
		$head = array();
		$fields = esse($def['fields'], $table);
		if ($fields) {
			foreach ($fields as $field => $prop) {
				if (empty($prop['list'])) continue;
				$head[$field] = $prop;
			}
		}
		$this->fields[$table] = $head;
		return $head;
	}
	
	private function build_head($table) {
		global $def;		
		$head = $this->fields_for_list($table);
		
		$thead = '<tr>';
		$cols = '';
		foreach($head as $field => $prop) {
			if (!empty($prop[$def['show']])) {
				$thead .= sprintf(self::htpl(2, 'th', 'class'), $prop[$def['show']], $field);
				$cols .= sprintf(self::htpl(1, 'col', 'class'), $field);
			}
		}
		$thead .= '</tr>';
		return array('thead' => $thead, 'cols' => $cols);
	}
	
	private function build_get(&$arr){
		$str = '';
		foreach ($arr as $key => $value) {
			$str .= urlencode($key) . '=' . urlencode($value) . '&';
		}
		return $str;
	}
	
	private function build_tbody($data, $table) {
		global $def;
		$subj = $this->subj;
		$thead = $this->fields_for_list($table);
		
		$tbody = $data['data'];
		$str = '';
		//print_r($thead);
		foreach($tbody as $row) {
			
			$str .= '<tr>';
			foreach($thead as $field => $prop) {
				if (!empty($prop[$def['show']])) {
/*!!*/					$value = def_e($row[$field]); 
					$extra = null;
					$tpl = null;
					$link = esse($prop, 'link');
					if ($link == 2) { //а что ещё там может быть?.. (2 - primary key)
						$pk = Config::get_key($subj, $row);
						$pk = $pk['where'];
						$extra = urlencode($subj) . '?' . $this->build_get($pk);
						$tpl = 'a';
					}
					$value = array($value, $extra, $tpl);
					$html = (!empty($value[2])) 
					? sprintf(self::htpl(2, $value[2]), $value[0], $value[1]) 
					: $value[0];
					
					$str .= sprintf(self::htpl(2, 'td'), $html);
				}
			}
			$str .= '</tr>';
		}
		
		return $str;
	
	} //subclass Table
	
	//subclass Item (list, именованный список)
	
	private function build_item($table) {
		global $def;
		$fields = $def['fields'][$table];
		$data = $this->data['data'];
		$item = each($data); 
		$item = $item['value']; 
		
		$str = '';
		$alt = '';
		
		foreach ($item as $key => $value) {
			$name = esse($fields[$key], $def['show']);
			if (!$name) continue;
			$html = sprintf(self::htpl(2, 'strong'), $name) . ': ' . $value;
			$str .= sprintf(self::htpl(2, 'p'), $html);
		}
		$alt = each($item);
		$alt = $alt['value']; 
		
		if ($def['request']['full_key']) {
			$src = $def['request']['where'];
			rsort($src);
			$src = implode('_', $src);
			$img = 'img/' . $src . '.gif';
			
			if (file_exists($def['site_path'] . '/' . $img))
				$str .= sprintf(self::htpl(1, 'img'), $img, $alt);
		}
		
		return Templates::item($str);;
	} //subclass Item
	
	//subclass form_ini
	
	private function build_form_ini() {
		$data = $this->data['data'];
		
		$str = '<form action="write.com" method="post">' . CR;
		
		foreach ($data as $sect => $props) {
			if (!is_array($props)) continue; //выкидываем параметры вне секций на
			$str .= '<div>' . sprintf(self::htpl(2, 'h3'), $sect);
			foreach ($props as $key => $value) {
				$str .= $this->build_input('set[' . $sect . ']' . '[' . $key . ']', $value, 'text', $key) . CR;
			}
			$str .= '</div>' . CR;
		}
		$str .= $this->build_input('subj', $this->subj, 'hidden', '', '') . CR;
		$str .= '<br>' . $this->build_input('go', 'Сохранить', 'submit', '', '') . CR;
		$str .= '</form>' . CR;
		return $str;
	}
	
	private function build_input($key, $value, $type = 'text', $view_name, $key_tag = 'span', $row_tag = 'p') {
		if (!isset($view_name)) $view_name = $key;
		$str = '';
		if ($key_tag) $str .= sprintf(self::htpl(2, $key_tag), $view_name . ': ');
		$str .= sprintf(self::htpl(1, 'input', 'name', 'value', 'type'), $key, $value, $type);
		return sprintf(self::htpl(2, $row_tag), $str);
	}//subclass form_ini
	
	public static function write($subj) {
		global $def;
		$err = Data::write($subj);
		if (!$err) header('Location: ' . $def['env']['referer']);
		else self::print_error($err);
	}
	
	public static function print_error($err) {
		print self::tpl_error($err);
	}
	
	public static function tpl_error($s) {
		return sprintf(self::htpl(2, 'div', 'style'), $s, 'margin:5em auto; width:40em; text-align:left; padding:1em; border:2px solid red;');
	}
	
	public static function htpl() {
		$def = array(
			'img' => array('src', 'alt'),
			'a' => array('href'),
		);
		
		$args = func_get_args();
		if (is_array($args[0])) $args = $args[0];
		$mode = intval(array_shift($args));
		$tag = array_shift($args);
		if (!count($args)) $args = esse($def, $tag);
		if (!$args) $args = array();
		$attrs = '';
		
		foreach ($args as $key => $attr) $attrs .= ' ' . $attr . '="%' . ($key + $mode) . "\$s\" ";
		
		return ($mode == 1) ? '<' . $tag . $attrs . ' />' 
			: '<' . $tag . $attrs . ">%1\$s</" . $tag . '>';
		
	}
	
} //class View